/* driver.h : Driver specific stuff
 *   Color
 *   Mouse
 */

/* ******************************************************************** */
/* ****************************** Color ******************************* */
/* ******************************************************************** */

	/* Constants used by do_color() */
#define TEXT_COLOR	0
#define MODELINE_COLOR	1
#define CURSOR_COLOR	2
#define CURSOR_SHAPE	3

	/* Constants used by setcolor() (display.c) */
#define FORCE_COLOR	1 /* current_color may not be correct - force color */
#define SWITCH_COLOR	2 /* switch color (if not already current_color) */
#define SWITCH_COLOR1	3 /* same as SWITCH_COLOR but at beginning of line */

/* ******************************************************************** */
/* ****************************** Mouse ******************************* */
/* ******************************************************************** */

#define MOUSE_KEY	(SHIFT|'m')

	/* Mouse states: */
#define BUTTON_DOWN	0
#define BUTTON_UP	1
#define BUTTON_CLICK	2
#define BUTTON_2CLICK	3
#define BUTTON_NOP	100

	/* Mouse buttons: 1-5 */

typedef struct
{
  int
    button,		/* 1, 2, ... 5 */
    row, column,	/* character where the mouse is */
    state,		/* mouse state */
    modifiers;		/* bit OR of SHIFT, CNTL, META, etc */
} MouseInfo;
